Index: /trunk/SophyaLib/BaseTools/Makefile
===================================================================
--- /trunk/SophyaLib/BaseTools/Makefile	(revision 2443)
+++ /trunk/SophyaLib/BaseTools/Makefile	(revision 2444)
@@ -16,7 +16,4 @@
  objfio.h anydataobj.h ppersist.h pexceptions.h gnumd5.h mutyv.h \
  $(INC)strutil.h
-$(OBJ)fiondblock.o: fiondblock.cc $(INC)machdefs.h \
- pexceptions.h fiondblock.h ppersist.h gnumd5.h ndatablock.h \
- anydataobj.h piocmplx.h
 $(OBJ)mutyv.o: mutyv.cc mutyv.h $(INC)machdefs.h
 $(OBJ)ndatablock.o: ndatablock.cc $(INC)machdefs.h \
Index: /trunk/SophyaLib/NTools/Makefile
===================================================================
--- /trunk/SophyaLib/NTools/Makefile	(revision 2443)
+++ /trunk/SophyaLib/NTools/Makefile	(revision 2444)
@@ -50,5 +50,6 @@
  $(INC)utilarr.h \
  $(INC)fioarr.h \
- $(INC)tvector.h
+ $(INC)tvector.h \
+ $(INC)datatype.h
 $(OBJ)cspline.o: cspline.cc $(INC)machdefs.h \
  nbtri.h cspline.h $(INC)pexceptions.h
@@ -211,6 +212,6 @@
  $(INC)perrors.h fmath.h \
  $(INC)sopemtx.h
-$(OBJ)integ.o: integ.cc integ.h classfunc.h $(INC)machdefs.h \
- $(INC)pexceptions.h generalfit.h \
+$(OBJ)integ.o: integ.cc integ.h $(INC)machdefs.h \
+ $(INC)pexceptions.h classfunc.h generalfit.h \
  $(INC)tvector.h \
  $(INC)tmatrix.h \
Index: /trunk/SophyaLib/Samba/Makefile
===================================================================
--- /trunk/SophyaLib/Samba/Makefile	(revision 2443)
+++ /trunk/SophyaLib/Samba/Makefile	(revision 2444)
@@ -105,5 +105,4 @@
  $(INC)mutyv.h \
  $(INC)ndatablock.h \
- $(INC)piocmplx.h \
  $(INC)fiondblock.h \
  $(INC)smathconst.h
Index: /trunk/SophyaLib/Samba/scan.cc
===================================================================
--- /trunk/SophyaLib/Samba/scan.cc	(revision 2443)
+++ /trunk/SophyaLib/Samba/scan.cc	(revision 2444)
@@ -6,5 +6,4 @@
 #include "scan.h"
 #include <complex>
-#include "piocmplx.h"
 #include "fiondblock.h"
 
Index: /trunk/SophyaLib/SkyMap/Makefile
===================================================================
--- /trunk/SophyaLib/SkyMap/Makefile	(revision 2443)
+++ /trunk/SophyaLib/SkyMap/Makefile	(revision 2444)
@@ -44,5 +44,7 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h localmap.h \
- $(INC)fiondblock.h
+ $(INC)fioarr.h \
+ $(INC)fiondblock.h \
+ $(INC)datatype.h
 $(OBJ)fiospherehealpix.o: fiospherehealpix.cc fiospherehealpix.h \
  sphericalmap.h $(INC)smathconst.h \
@@ -62,5 +64,6 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h spherehealpix.h \
- HEALPixUtils.h $(INC)fiondblock.h
+ HEALPixUtils.h $(INC)fiondblock.h \
+ $(INC)datatype.h
 $(OBJ)fiospherethetaphi.o: fiospherethetaphi.cc fiospherethetaphi.h \
  sphericalmap.h $(INC)smathconst.h \
@@ -80,5 +83,6 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h spherethetaphi.h \
- $(INC)fiondblock.h
+ $(INC)fiondblock.h \
+ $(INC)datatype.h
 $(OBJ)localmap.o: localmap.cc localmap.h pixelmap.h \
  $(INC)ppersist.h \
@@ -98,6 +102,6 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
- $(INC)piocmplx.h \
- $(INC)fiondblock.h
+ $(INC)fiondblock.h \
+ $(INC)timing.h
 $(OBJ)longlat.o: longlat.cc longlat.h \
  $(INC)machdefs.h utilgeom.h
@@ -157,5 +161,6 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h unitvector.h vector3d.h \
- longlat.h utilgeom.h $(INC)anydataobj.h
+ longlat.h utilgeom.h $(INC)anydataobj.h \
+ $(INC)datatype.h
 $(OBJ)spherethetaphi.o: spherethetaphi.cc spherethetaphi.h sphericalmap.h \
  $(INC)smathconst.h \
@@ -175,9 +180,9 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
- $(INC)piocmplx.h \
  $(INC)fiondblock.h
 $(OBJ)unitvector.o: unitvector.cc unitvector.h vector3d.h longlat.h \
  $(INC)machdefs.h utilgeom.h
-$(OBJ)utilgeom.o: utilgeom.cc utilgeom.h
+$(OBJ)utilgeom.o: utilgeom.cc $(INC)machdefs.h \
+ utilgeom.h
 $(OBJ)vector3d.o: vector3d.cc $(INC)machdefs.h \
  $(INC)pexceptions.h vector3d.h longlat.h \
Index: /trunk/SophyaLib/SkyT/Makefile
===================================================================
--- /trunk/SophyaLib/SkyT/Makefile	(revision 2443)
+++ /trunk/SophyaLib/SkyT/Makefile	(revision 2444)
@@ -46,5 +46,6 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
- $(INC)integ.h
+ $(INC)integ.h \
+ $(INC)classfunc.h
 $(OBJ)radspecvector.o: radspecvector.cc \
  $(INC)machdefs.h radspecvector.h radspec.h \
@@ -85,4 +86,5 @@
  $(INC)integ.h \
  $(INC)pexceptions.h \
+ $(INC)classfunc.h \
  $(INC)tvector.h \
  $(INC)tmatrix.h \
Index: /trunk/SophyaLib/TArray/Makefile
===================================================================
--- /trunk/SophyaLib/TArray/Makefile	(revision 2443)
+++ /trunk/SophyaLib/TArray/Makefile	(revision 2444)
@@ -28,5 +28,6 @@
  basarr.h $(INC)mutyv.h \
  $(INC)dvlist.h \
- $(INC)objfio.h utilarr.h tmatrix.h tvector.h
+ $(INC)objfio.h utilarr.h tmatrix.h tvector.h \
+ $(INC)datatype.h
 $(OBJ)matharr.o: matharr.cc $(INC)machdefs.h \
  matharr.h tarray.h basarr.h \
Index: /trunk/SophyaPI/PI/Makefile
===================================================================
--- /trunk/SophyaPI/PI/Makefile	(revision 2443)
+++ /trunk/SophyaPI/PI/Makefile	(revision 2444)
@@ -160,5 +160,5 @@
  $(INC)machdefs.h piwdgx.h piwdggen.h \
  pimsghandler.h picolist.h picmap.h picmapx.h picmapgen.h pifontx.h \
- pifontgen.h pigrcoord.h pilineatt.h
+ pifontgen.h pigrcoord.h pilineatt.h ucckprot.h
 $(OBJ)pigraphps.o: pigraphps.cc pigraphps.h pisysdep.h \
  $(INC)machdefs.h pigraphgen.h piwdgx.h \
@@ -176,18 +176,19 @@
  $(INC)machdefs.h pigraphgen.h piwdgx.h \
  piwdggen.h pimsghandler.h picolist.h picmap.h picmapx.h picmapgen.h \
- pifontx.h pifontgen.h pigrcoord.h pilineatt.h
+ pifontx.h pifontgen.h pigrcoord.h pilineatt.h \
+ $(INC)strutilxx.h
 $(OBJ)pigrcoord.o: pigrcoord.cc pigrcoord.h pisysdep.h \
  $(INC)machdefs.h
-$(OBJ)piimage.o: piimage.cc piimage.h parradapter.h \
- $(INC)machdefs.h lut.h pisysdep.h pieldrw.h \
- pidrawer.h pibwdggen.h piwdgx.h piwdggen.h pimsghandler.h picolist.h \
- picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h pifontx.h \
- pifontgen.h pigrcoord.h pilineatt.h pigraphuc.h pievthandler.h \
- psfile.h pigratt.h piaxes.h pipixmapx.h pipixmapgen.h pibwdgx.h \
- pigraphps.h pistdwdgx.h pistdwdggen.h piwindowx.h piwindowgen.h \
- picontainerx.h picontainergen.h picmapview.h piimgtools.h \
- pioptmenux.h pioptmenugen.h pimenux.h pimenugen.h piapplx.h \
- piapplgen.h pimenubarx.h pimenubargen.h picons.h pidrwtools.h \
- piscdrawwdg.h piyfxdrw.h
+$(OBJ)piimage.o: piimage.cc pisysdep.h \
+ $(INC)machdefs.h piimage.h parradapter.h \
+ lut.h pieldrw.h pidrawer.h pibwdggen.h piwdgx.h piwdggen.h \
+ pimsghandler.h picolist.h picmap.h picmapx.h picmapgen.h pigraphx.h \
+ pigraphgen.h pifontx.h pifontgen.h pigrcoord.h pilineatt.h \
+ pigraphuc.h pievthandler.h psfile.h pigratt.h piaxes.h pipixmapx.h \
+ pipixmapgen.h pibwdgx.h pigraphps.h pistdwdgx.h pistdwdggen.h \
+ piwindowx.h piwindowgen.h picontainerx.h picontainergen.h \
+ picmapview.h piimgtools.h pioptmenux.h pioptmenugen.h pimenux.h \
+ pimenugen.h piapplx.h piapplgen.h pimenubarx.h pimenubargen.h \
+ picons.h pidrwtools.h piscdrawwdg.h piyfxdrw.h
 $(OBJ)piimgtools.o: piimgtools.cc piimgtools.h pisysdep.h \
  $(INC)machdefs.h pistdwdgx.h pistdwdggen.h \
@@ -297,5 +298,5 @@
  picontainerx.h pisysdep.h picontainergen.h pievthandler.h pigraphx.h \
  pigraphgen.h picmap.h picmapx.h picmapgen.h pifontx.h pifontgen.h \
- pigrcoord.h pilineatt.h
+ pigrcoord.h pilineatt.h $(INC)pexceptions.h
 $(OBJ)piwindowgen.o: piwindowgen.cc piwindowgen.h pisysdep.h \
  $(INC)machdefs.h picontainerx.h \
@@ -306,8 +307,8 @@
  $(INC)machdefs.h picontainerx.h \
  picontainergen.h piwdgx.h piwdggen.h pimsghandler.h picolist.h
-$(OBJ)pixtbase.o: pixtbase.cc pixtbaseP.h pibwdgx.h pisysdep.h \
- $(INC)machdefs.h pibwdggen.h piwdgx.h \
- piwdggen.h pimsghandler.h picolist.h picmap.h picmapx.h picmapgen.h \
- pigraphx.h pigraphgen.h pifontx.h pifontgen.h pigrcoord.h pilineatt.h \
+$(OBJ)pixtbase.o: pixtbase.cc $(INC)machdefs.h \
+ pixtbaseP.h pibwdgx.h pisysdep.h pibwdggen.h piwdgx.h piwdggen.h \
+ pimsghandler.h picolist.h picmap.h picmapx.h picmapgen.h pigraphx.h \
+ pigraphgen.h pifontx.h pifontgen.h pigrcoord.h pilineatt.h \
  pigraphuc.h pievthandler.h psfile.h pigraphps.h pixtbase.h
 $(OBJ)piyfxdrw.o: piyfxdrw.cc $(INC)machdefs.h \