Index: /trunk/ArchTOIPipe/Kernel/fitsringrdr.cc
===================================================================
--- /trunk/ArchTOIPipe/Kernel/fitsringrdr.cc	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/fitsringrdr.cc	(revision 2448)
@@ -2,5 +2,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: fitsringrdr.cc,v 1.6 2003-04-24 13:29:38 aubourg Exp $
+// $Id: fitsringrdr.cc,v 1.7 2003-10-13 20:48:36 aubourg Exp $
 
 #include "fitsringrdr.h"
@@ -79,15 +79,15 @@
 }
 
-int FITSRingReader::calcMinOut() {
+long FITSRingReader::calcMinOut() {
   chkinit();
   TOIManager* mgr = TOIManager::getManager();
-  int firstReq = mgr->getRequestedBegin();
+  long firstReq = mgr->getRequestedBegin();
   return snBegin > firstReq ? snBegin : firstReq;
 }
 
-int FITSRingReader::calcMaxOut() {
+long FITSRingReader::calcMaxOut() {
   chkinit();
   TOIManager* mgr = TOIManager::getManager();
-  int lastReq = mgr->getRequestedEnd();
+  long lastReq = mgr->getRequestedEnd();
   return snEnd < lastReq ? snEnd : lastReq;
 }
Index: /trunk/ArchTOIPipe/Kernel/fitsringrdr.h
===================================================================
--- /trunk/ArchTOIPipe/Kernel/fitsringrdr.h	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/fitsringrdr.h	(revision 2448)
@@ -6,5 +6,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: fitsringrdr.h,v 1.3 2003-04-01 13:27:48 aubourg Exp $
+// $Id: fitsringrdr.h,v 1.4 2003-10-13 20:48:36 aubourg Exp $
 
 #ifndef FITSRINGRDR_H
@@ -35,6 +35,6 @@
 
 protected:
-  virtual int   calcMinOut();
-  virtual int   calcMaxOut();
+  virtual long  calcMinOut();
+  virtual long  calcMaxOut();
   
   // ajout vf 31/07/2002
Index: /trunk/ArchTOIPipe/Kernel/fitstoirdr.cc
===================================================================
--- /trunk/ArchTOIPipe/Kernel/fitstoirdr.cc	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/fitstoirdr.cc	(revision 2448)
@@ -3,5 +3,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: fitstoirdr.cc,v 1.42 2002-09-16 13:28:29 aubourg Exp $
+// $Id: fitstoirdr.cc,v 1.43 2003-10-13 20:48:37 aubourg Exp $
 
 #include "fitstoirdr.h"
@@ -178,15 +178,15 @@
 }
 
-int FITSTOIReader::calcMinOut() {
+long FITSTOIReader::calcMinOut() {
   chkinit();
   TOIManager* mgr = TOIManager::getManager();
-  int firstReq = mgr->getRequestedBegin();
+  long firstReq = mgr->getRequestedBegin();
   return snBegin > firstReq ? snBegin : firstReq;
 }
 
-int FITSTOIReader::calcMaxOut() {
+long FITSTOIReader::calcMaxOut() {
   chkinit();
   TOIManager* mgr = TOIManager::getManager();
-  int lastReq = mgr->getRequestedEnd();
+  long lastReq = mgr->getRequestedEnd();
   return snEnd < lastReq ? snEnd : lastReq;
 }
Index: /trunk/ArchTOIPipe/Kernel/fitstoirdr.h
===================================================================
--- /trunk/ArchTOIPipe/Kernel/fitstoirdr.h	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/fitstoirdr.h	(revision 2448)
@@ -5,5 +5,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: fitstoirdr.h,v 1.14 2002-10-07 14:23:02 aubourg Exp $
+// $Id: fitstoirdr.h,v 1.15 2003-10-13 20:48:37 aubourg Exp $
 
 
@@ -45,6 +45,6 @@
 
 protected:
-  virtual int   calcMinOut();
-  virtual int   calcMaxOut();
+  virtual long calcMinOut();
+  virtual long calcMaxOut();
   
   // ajout vf 31/07/2002
Index: /trunk/ArchTOIPipe/Kernel/piotoirdr.cc
===================================================================
--- /trunk/ArchTOIPipe/Kernel/piotoirdr.cc	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/piotoirdr.cc	(revision 2448)
@@ -3,5 +3,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: piotoirdr.cc,v 1.10 2003-06-05 08:15:47 aubourg Exp $
+// $Id: piotoirdr.cc,v 1.11 2003-10-13 20:48:37 aubourg Exp $
 
 #include "piotoirdr.h"
@@ -93,9 +93,9 @@
        << snBegin << " " << snEnd << endl;
 
-  for (int snb = snBegin; snb <= snEnd; snb += bufferSize) {
-    int sne = snb + bufferSize - 1;
+  for (long snb = snBegin; snb <= snEnd; snb += bufferSize) {
+    long sne = snb + bufferSize - 1;
     if (sne > snEnd) sne=snEnd;
     // TBD : check if PIODOUBLE != double;
-    char command[80];
+    char command[128];
     sprintf(command, "Begin=%d; End=%d", snb, sne);
     double* data = NULL;
@@ -103,6 +103,8 @@
     PIOBYTE*  pioflags = NULL;
     fits_lock();
+    char objname[128];
+    strcpy(objname, object.c_str());
     PIOLONG n = PIOReadTOI((void**) &data,
-			   const_cast<char*>(object.c_str()),
+			   objname,
 			   "PIODOUBLE",
 			   command,
@@ -113,8 +115,10 @@
     }
     if (flagdef != "") {
+      char flagname[128];
+      strcpy(flagname, flagdef.c_str());
       PIOLONG nf = PIOReadFLGObjectMask(&pioflags,
-				       const_cast<char*>(flagdef.c_str()),
-				       command,
-				       pioGroup);
+					flagname,
+					command,
+					pioGroup);
       if (nf != n) {
 	cerr << "*** PIO Error, inconsistent read, data " << n << " flags " 
Index: /trunk/ArchTOIPipe/Kernel/toimanager.cc
===================================================================
--- /trunk/ArchTOIPipe/Kernel/toimanager.cc	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/toimanager.cc	(revision 2448)
@@ -3,5 +3,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: toimanager.cc,v 1.23 2003-05-28 21:03:53 aubourg Exp $
+// $Id: toimanager.cc,v 1.24 2003-10-13 20:48:37 aubourg Exp $
 
 #include "toimanager.h"
@@ -11,4 +11,8 @@
 #include <unistd.h>
 #include <map>
+
+//#ifndef NOCFITSIO
+#include "fitstoiwtr.h"
+//#endif
 
 #ifndef MAXINT
@@ -139,5 +143,5 @@
 // fin ajout vf
 
-void TOIManager::setRequestedSample(int begin, int end) {
+void TOIManager::setRequestedSample(long begin, long end) {
   cout << "TOIManager::setRequestedSample should not be called anymore" << endl;
   cout << " call same method one any toiprocessor" << endl;
@@ -229,7 +233,11 @@
 
   if (withFlag) { // Si c'est un FITSTOIWriter
+    //#ifndef NOCFITSIO
     FITSTOIWriter* ftw = dynamic_cast< FITSTOIWriter* >(&prin);
     if (ftw) ftw->addInput(in, toi, withFlag);
     else prin.addInput(in, toi);
+    //#else
+    //    prin.addInput(in, toi);
+    //#endif
   }
   else prin.addInput(in, toi);
Index: /trunk/ArchTOIPipe/Kernel/toimanager.h
===================================================================
--- /trunk/ArchTOIPipe/Kernel/toimanager.h	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/toimanager.h	(revision 2448)
@@ -5,5 +5,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: toimanager.h,v 1.18 2003-05-20 10:10:09 aubourg Exp $
+// $Id: toimanager.h,v 1.19 2003-10-13 20:48:37 aubourg Exp $
 
 
@@ -25,5 +25,5 @@
 #include "toiseqbuff.h"
 #include "toisegment.h"
-#include "fitstoiwtr.h"
+//#include "fitstoiwtr.h"
 
 #ifdef WITH_SOPHYA
@@ -44,5 +44,5 @@
   static TOIManager* getManager();
   virtual ~TOIManager() {}
-  void setRequestedSample(int begin, int end);
+  void setRequestedSample(long begin, long end);
   int getRequestedBegin();
   int getRequestedEnd();
Index: /trunk/ArchTOIPipe/Kernel/toiprocessor.cc
===================================================================
--- /trunk/ArchTOIPipe/Kernel/toiprocessor.cc	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/toiprocessor.cc	(revision 2448)
@@ -3,5 +3,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: toiprocessor.cc,v 1.27 2002-11-28 15:49:21 aubourg Exp $
+// $Id: toiprocessor.cc,v 1.28 2003-10-13 20:48:37 aubourg Exp $
 
 #include "toiprocessor.h"
@@ -93,28 +93,28 @@
 }
 
-int TOIProcessor::getMinOut() {
+long TOIProcessor::getMinOut() {
   //  return snBegin + lowExtra;
   return snBegin;
 }
 
-int TOIProcessor::getMaxOut() {
+long TOIProcessor::getMaxOut() {
   //  return snEnd - upExtra;
   return snEnd;
 }
 
-int TOIProcessor::calcMinOut() {
+long TOIProcessor::calcMinOut() {
   return getMinIn() + lowExtra;
 }
 
-int TOIProcessor::calcMaxOut() {
+long TOIProcessor::calcMaxOut() {
   return getMaxIn() - upExtra;
 }
 
-int TOIProcessor::getMinIn() {
+long TOIProcessor::getMinIn() {
   //  return snBegin;
   return snBegin - lowExtra;
 }
 
-int TOIProcessor::getMaxIn() {
+long TOIProcessor::getMaxIn() {
   //  return snEnd;
   return snEnd + upExtra;
@@ -312,5 +312,5 @@
 #ifndef NO_SOPHYA
 /* ---- l'interface va etre modifiee, NE PAS UTILISER
-Array TOIProcessor::getData(int toiIndex, int iStart, int iEnd) {
+Array TOIProcessor::getData(int toiIndex, long iStart, long iEnd) {
   TOI* toi = getInputTOI(toiIndex);
   toi->waitForData(iStart, iEnd);
@@ -318,5 +318,5 @@
 }
 
-Array TOIProcessor::getError(int toiIndex, int iStart, int iEnd) {
+Array TOIProcessor::getError(int toiIndex, long iStart, long iEnd) {
   TOI* toi = getInputTOI(toiIndex);
   toi->waitForData(iStart, iEnd);
@@ -324,5 +324,5 @@
 }
 
-TArray<int_4> TOIProcessor::getFlag(int toiIndex, int iStart, int iEnd) {
+TArray<int_4> TOIProcessor::getFlag(int toiIndex, long iStart, long iEnd) {
   TOI* toi = getInputTOI(toiIndex);
   toi->waitForData(iStart, iEnd);
@@ -332,5 +332,5 @@
 #endif
 
-double TOIProcessor::getData(int toiIndex, int i) {
+double TOIProcessor::getData(int toiIndex, long i) {
   TOI* toi = getInputTOI(toiIndex);
   if (toi->needSyncOldWay()) toi->waitForData(i); // seulement pour autre que segmented
@@ -339,5 +339,5 @@
 }
 
-void  TOIProcessor::getData(int toiIndex, int i, double &data, uint_8 &flag)
+void  TOIProcessor::getData(int toiIndex, long i, double &data, uint_8 &flag)
 {
   TOI* toi = getInputTOI(toiIndex);
@@ -348,5 +348,5 @@
 }
 
-void TOIProcessor::getData(int toiIndex, int i, int n, double* d) 
+void TOIProcessor::getData(int toiIndex, long i, long n, double* d) 
 {
   TOI* toi = getInputTOI(toiIndex);
@@ -357,5 +357,5 @@
 }
 
-void TOIProcessor::getData(int toiIndex, int i, int n, double* d, uint_8* f)
+void TOIProcessor::getData(int toiIndex, long i, long n, double* d, uint_8* f)
 {
   TOI* toi = getInputTOI(toiIndex);
@@ -368,5 +368,5 @@
 
 /*RZCMV 
-double TOIProcessor::getError(int toiIndex, int i) {
+double TOIProcessor::getError(int toiIndex, long i) {
   TOI* toi = getInputTOI(toiIndex);
   toi->waitForData(i);
@@ -374,5 +374,5 @@
 }
 
-int_4 TOIProcessor::getFlag(int toiIndex, int i) {
+int_4 TOIProcessor::getFlag(int toiIndex, long i) {
   TOI* toi = getInputTOI(toiIndex);
   toi->waitForData(i);
@@ -381,9 +381,9 @@
 */
 
-void TOIProcessor::setNeededHistory(int nsamples) {
+void TOIProcessor::setNeededHistory(long nsamples) {
   neededHistory =  nsamples;
 }
 
-void TOIProcessor::wontNeedBefore(int i) {
+void TOIProcessor::wontNeedBefore(long i) {
   if (i<wontNeedValue) return;
   wontNeedValue = i;
@@ -394,5 +394,5 @@
 }
 
-void TOIProcessor::autoWontNeed(int iCur) {
+void TOIProcessor::autoWontNeed(long iCur) {
   if (neededHistory <=0) return;
   if (iCur < lastAWN + neededHistory/10) return;
@@ -409,5 +409,5 @@
 
 
-void TOIProcessor::putData(int toiIndex, int i, double value, uint_8 flg) {
+void TOIProcessor::putData(int toiIndex, long i, double value, uint_8 flg) {
   TOI* toi = getOutputTOI(toiIndex);
   if (toi == NULL) return;
@@ -417,5 +417,5 @@
 }
 
-void TOIProcessor::putData(int toiIndex, int i, int n, double const* val,
+void TOIProcessor::putData(int toiIndex, long i, long n, double const* val,
 			   uint_8 const* flg) {
   TOI* toi = getOutputTOI(toiIndex);
@@ -426,5 +426,5 @@
 
 /*RZCMV
-void TOIProcessor::putDataError(int toiIndex, int i, double value, 
+void TOIProcessor::putDataError(int toiIndex, long i, double value, 
 				double error, int_4 flg) { 
   TOI* toi = getOutputTOI(toiIndex);
Index: /trunk/ArchTOIPipe/Kernel/toiprocessor.h
===================================================================
--- /trunk/ArchTOIPipe/Kernel/toiprocessor.h	(revision 2447)
+++ /trunk/ArchTOIPipe/Kernel/toiprocessor.h	(revision 2448)
@@ -5,5 +5,5 @@
 //                               Christophe Magneville
 //                               Reza Ansari
-// $Id: toiprocessor.h,v 1.20 2002-09-09 15:33:15 aubourg Exp $
+// $Id: toiprocessor.h,v 1.21 2003-10-13 20:48:37 aubourg Exp $
 
 
@@ -48,6 +48,6 @@
   virtual void run();
 
-  virtual int   getMinOut();
-  virtual int   getMaxOut();
+  virtual long  getMinOut();
+  virtual long  getMaxOut();
   
   // rajout vf 29/07/2002
@@ -71,7 +71,7 @@
 #ifndef NO_SOPHYA
   /* ---- l'interface va etre modifiee, NE PAS UTILISER
-  Array         getData(int toiIndex, int iStart, int iEnd);
-  Array         getError(int toiIndex, int iStart, int iEnd);
-  TArray<int_4> getFlag(int toiIndex, int iStart, int iEnd);
+  Array         getData(int toiIndex, long iStart, long iEnd);
+  Array         getError(int toiIndex, long iStart, long iEnd);
+  TArray<int_4> getFlag(int toiIndex, long iStart, long iEnd);
           l'interface va etre modifiee, NE PAS UTILISER ---- */
 #endif
@@ -80,22 +80,22 @@
   // Les methodes qui suivent ne peuvent etre 
   // utilisees que sur des entrees simples
-  double        getData(int toiIndex, int i);
-  void          getData(int toiIndex, int i, double &data, uint_8 &flag);
-
-  void          getData(int toiIndex, int i, int n, double* d);
-  void          getData(int toiIndex, int i, int n, double* d, uint_8* f);
-  
-  //RZCMV  double        getError(int toiIndex, int i);
-  //RZCMV  int_4         getFlag(int toiIndex, int i);
-
-  void          wontNeedBefore(int i);
-  int           wontNeedValue;
-  void          setNeededHistory(int nsamples); // -1 : disable
-
-  void          putData(int toiIndex, int i, double value, uint_8 flag=0);
-  //RZCMV  void          putDataError(int toiIndex, int i, double value, 
+  double        getData(int toiIndex, long i);
+  void          getData(int toiIndex, long i, double &data, uint_8 &flag);
+
+  void          getData(int toiIndex, long i, long n, double* d);
+  void          getData(int toiIndex, long i, long n, double* d, uint_8* f);
+  
+  //RZCMV  double        getError(int toiIndex, long i);
+  //RZCMV  int_4         getFlag(int toiIndex, long i);
+
+  void          wontNeedBefore(long i);
+  long           wontNeedValue;
+  void          setNeededHistory(long nsamples); // -1 : disable
+
+  void          putData(int toiIndex, long i, double value, uint_8 flag=0);
+  //RZCMV  void          putDataError(int toiIndex, long i, double value, 
   //RZCMV		             double error, int_4 flag=0);
 
-  void          putData(int toiIndex, int i, int n, double const* val,
+  void          putData(int toiIndex, long i, long n, double const* val,
 			uint_8 const* flg=0);
 
@@ -103,20 +103,20 @@
 public:  
   // Methodes passees en public par Reza, 14/5/2002
-  virtual int   calcMinOut(); // Protected ?
-  virtual int   calcMaxOut(); // Protected ?
-
-  virtual int   getMinIn();
-  virtual int   getMaxIn();
+  virtual long   calcMinOut(); // Protected ?
+  virtual long   calcMaxOut(); // Protected ?
+
+  virtual long   getMinIn();
+  virtual long   getMaxIn();
 protected:
   // Implementation par defaut
-  int           minOut;    // Cache for calcMinOut() value. Protected ?
-  int           maxOut;    // Cache for calcMaxOut() value. Protected ?
+  long           minOut;    // Cache for calcMinOut() value. Protected ?
+  long           maxOut;    // Cache for calcMaxOut() value. Protected ?
 
   int           upExtra;  // MaxIn - MaxOut : extra samples for processing
   int           lowExtra; // MinOut - MinIn : extra samples for processing
 
-  int           forcedMinIn; // to process a subset of data
-  int           forcedMaxIn; // to process a subset of data
-  void          setSampleSubset(int min, int max);
+  long           forcedMinIn; // to process a subset of data
+  long           forcedMaxIn; // to process a subset of data
+  void          setSampleSubset(long min, long max);
 
   int           neededHistory;
@@ -134,6 +134,6 @@
   //  Fin rajout Reza 11/3/2001 
 
-  void          autoWontNeed(int iCur);
-  int           lastAWN;
+  void          autoWontNeed(long iCur);
+  long           lastAWN;
 
 
@@ -158,6 +158,6 @@
   virtual ~TOIProcessor();
   
-  void setMinSn(int n) {forcedMinIn = n;}
-  void setMaxSn(int n) {forcedMaxIn = n;}
+  void setMinSn(long n) {forcedMinIn = n;}
+  void setMaxSn(long n) {forcedMaxIn = n;}
 
   // ajout vf 23/08/2002